;title  "uart - Simple 3-Wire RS-232 Application"
;
;
;  Hardware Notes:
;   16F628 Running at 4 MHz
;   _MCLR is Pulled Up
;   
;

  LIST P=16F628, R=DEC
  INCLUDE "p16f628.inc"


 PAGE
 __CONFIG _CP_OFF & _XT_OSC & _PWRTE_ON  & _WDT_OFF ^ _BODEN_ON

#define ClkFreq		4000000		; clock frequency
#define baud(X)		((10*ClkFreq/(64*X))+5)/10-1
#define TXSTA_INIT	0xA0			
#define RCSTA_INIT	b'10010000'
#define LED		PORTA, 0

;  Mainline of TrueRS
  org    0

Setup_Async_Mode
  bsf    STATUS, RP0		;  Enable the Serial Port
  bcf	 LED			;  Set LED as an Output
  movlw  baud(2400)		;  Make the Serial Port Run at 2400 bps
  movwf  SPBRG
  movlw  TXSTA_INIT
  movwf  TXSTA
  movlw	 RCSTA_INIT
  bcf    STATUS, RP0
  movwf  RCSTA 			;  Enable Serial I/O

Loop
  btfss   PIR1, RCIF            ;  Wait for Received Character Set
   goto   Loop                  ;   - Nothing There
  movf    RCREG, w	        ;  Get the Received Character
  bcf     PIR1, RCIF	        ;  Clear the Character Present Flag

  movwf  TXREG			;  Send the Character

  goto   Loop
;****************************************************
toggle
  btfsc	LED
  goto  togclr
  bsf   LED
  return
;****************************************************
togclr
  bcf 	LED
  return  
;****************************************************
 end
